#include<p18f4520.h>
#include<delays.h>
#include<i2c.h>
#include<math.h>

#pragma config FCMEN=ON, WDT=OFF, IESO=OFF, XINST=OFF, LVP=OFF
#pragma code
// code 7seg
unsigned char table[10] = {0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0x00,0x10};



void delay(unsigned int t);

void write_ds(unsigned char diachighi, unsigned char dulieu);
void read_ds(unsigned char diachidoc);
int bcd_int(char x);
int int_bcd(int y);
void display(void);
int h=10,m=20,s=30;
int temp;


void delay(unsigned int t)
{
unsigned int i;
for(i=0;i<=t;i++);
}
//++-------------------------


void write_ds(unsigned char diachighi, unsigned char dulieu)
{
StartI2C();
IdleI2C();
WriteI2C(0xD0);
IdleI2C();
WriteI2C(diachighi);
IdleI2C();
WriteI2C(int_bcd(dulieu));
IdleI2C();
StopI2C();
}
//++-------------------------
void read_ds(unsigned char diachidoc)
{
	StartI2C();
IdleI2C();
WriteI2C(0xD0);
IdleI2C();
WriteI2C(diachidoc);
IdleI2C();
RestartI2C();
IdleI2C();
WriteI2C(0xD1);
IdleI2C();
temp= ReadI2C();
IdleI2C();
NotAckI2C();
IdleI2C();
StopI2C();
}
//++-------------------------
int bcd_int(char x)
{
return((((x&0xF0)>>4)*10)+(x&0x0F));
}
//*********************************
int int_bcd(int y)
{
return((((y/10)<<4)&0xf0)+((y%10)&0x0f));
}
//--------------------------------

void display(void)
{
read_ds(0x00);
s =bcd_int(temp);
read_ds(0x01);
m = bcd_int(temp);
read_ds(0x02);
h = bcd_int(temp);


    TRISB=0x00;
	TRISD=0x00;

	LATB=0x00;

	LATD=table[h/10];
	LATB=0b00000001;
	Delay100TCYx(50);
	LATB=0x00;

	LATD=table[h%10];
	LATB=0b00000010;
	Delay100TCYx(50);
    LATB=0x00;

	LATD=table[m/10];
	LATB=0b00000100;
	Delay100TCYx(50);
    LATB=0x00;

	LATD=table[m%10];
	LATB=0b00001000;
	Delay100TCYx(50);
    LATB=0x00;

	LATD=table[s/10];
	LATB=0b00010000;
	Delay100TCYx(50);
    LATB=0x00;

	LATD=table[s%10];
	LATB=0b00100000;
	Delay100TCYx(50);
    LATB=0x00;


}
//++-------------------------
void main(void)
{
TRISB=0x00;
TRISD=0x00;
TRISC=0xFF;



OpenI2C(MASTER, SLEW_ON);
SSPADD=9;
delay(1000);

  SSPCON1bits.WCOL = 0;
	SSPCON1bits.SSPOV = 0;
	SSPCON1bits.SSPM3 = 1;			// master I2C, baute = Fosc/(4*(SSPADD + 1))
	SSPCON1bits.SSPM2 = 0;			//
	SSPCON1bits.SSPM1 = 0;			//
	SSPCON1bits.SSPM0 = 0;			//
	SSPCON1bits.SSPEN = 1;
write_ds(0x00,0x00);
delay(500);
write_ds(0x01,0x05);
delay(500);
write_ds(0x02,0x05);
delay(500);
write_ds(0x07,0xD0);
delay(500); 

while(1)
{

display();
}
}
